# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "device4xi.py">
#<abstract4xi abstract = "Device management"/>
#<refer4xi reference = "Devices"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Device4Xi',
            'init2device4xi',
            'get2device4xi',
            'set2device4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

from apu2device4xi import APU4Xi
from bpu2device4xi import BPU4Xi 
from cpu2device4xi import CPU4Xi 
from dpu2device4xi import DPU4Xi 
from epu2device4xi import EPU4Xi 
from fpu2device4xi import FPU4Xi 
from gpu2device4xi import GPU4Xi 
from hpu2device4xi import HPU4Xi 
from ipu2device4xi import IPU4Xi 
from jpu2device4xi import JPU4Xi 
from kpu2device4xi import KPU4Xi 
from lpu2device4xi import LPU4Xi 
from mpu2device4xi import MPU4Xi 
from npu2device4xi import NPU4Xi 
from opu2device4xi import OPU4Xi 
from ppu2device4xi import PPU4Xi 
from qpu2device4xi import QPU4Xi 
from rpu2device4xi import RPU4Xi 
from spu2device4xi import SPU4Xi 
from tpu2device4xi import TPU4Xi 
from upu2device4xi import UPU4Xi 
from vpu2device4xi import VPU4Xi 
from xpu2device4xi import XPU4Xi 
from wpu2device4xi import WPU4Xi 
from ypu2device4xi import YPU4Xi 
from zpu2device4xi import ZPU4Xi                                                                                   

from apu2device4xi import init2apu4xi
from bpu2device4xi import init2bpu4xi 
from cpu2device4xi import init2cpu4xi 
from dpu2device4xi import init2dpu4xi 
from epu2device4xi import init2epu4xi 
from fpu2device4xi import init2fpu4xi 
from gpu2device4xi import init2gpu4xi 
from hpu2device4xi import init2hpu4xi 
from ipu2device4xi import init2ipu4xi 
from jpu2device4xi import init2jpu4xi 
from kpu2device4xi import init2kpu4xi 
from lpu2device4xi import init2lpu4xi 
from mpu2device4xi import init2mpu4xi 
from npu2device4xi import init2npu4xi 
from opu2device4xi import init2opu4xi 
from ppu2device4xi import init2ppu4xi 
from qpu2device4xi import init2qpu4xi 
from rpu2device4xi import init2rpu4xi 
from spu2device4xi import init2spu4xi 
from tpu2device4xi import init2tpu4xi 
from upu2device4xi import init2upu4xi 
from vpu2device4xi import init2vpu4xi 
from xpu2device4xi import init2xpu4xi 
from wpu2device4xi import init2wpu4xi 
from ypu2device4xi import init2ypu4xi 
from zpu2device4xi import init2zpu4xi 

from apu2device4xi import get2apu4xi
from bpu2device4xi import get2bpu4xi 
from cpu2device4xi import get2cpu4xi 
from dpu2device4xi import get2dpu4xi 
from epu2device4xi import get2epu4xi 
from fpu2device4xi import get2fpu4xi 
from gpu2device4xi import get2gpu4xi 
from hpu2device4xi import get2hpu4xi 
from ipu2device4xi import get2ipu4xi 
from jpu2device4xi import get2jpu4xi 
from kpu2device4xi import get2kpu4xi 
from lpu2device4xi import get2lpu4xi 
from mpu2device4xi import get2mpu4xi 
from npu2device4xi import get2npu4xi 
from opu2device4xi import get2opu4xi 
from ppu2device4xi import get2ppu4xi 
from qpu2device4xi import get2qpu4xi 
from rpu2device4xi import get2rpu4xi 
from spu2device4xi import get2spu4xi 
from tpu2device4xi import get2tpu4xi 
from upu2device4xi import get2upu4xi 
from vpu2device4xi import get2vpu4xi 
from xpu2device4xi import get2xpu4xi 
from wpu2device4xi import get2wpu4xi 
from ypu2device4xi import get2ypu4xi 
from zpu2device4xi import get2zpu4xi       

from apu2device4xi import set2apu4xi
from bpu2device4xi import set2bpu4xi 
from cpu2device4xi import set2cpu4xi 
from dpu2device4xi import set2dpu4xi 
from epu2device4xi import set2epu4xi 
from fpu2device4xi import set2fpu4xi 
from gpu2device4xi import set2gpu4xi 
from hpu2device4xi import set2hpu4xi 
from ipu2device4xi import set2ipu4xi 
from jpu2device4xi import set2jpu4xi 
from kpu2device4xi import set2kpu4xi 
from lpu2device4xi import set2lpu4xi 
from mpu2device4xi import set2mpu4xi 
from npu2device4xi import set2npu4xi 
from opu2device4xi import set2opu4xi 
from ppu2device4xi import set2ppu4xi 
from qpu2device4xi import set2qpu4xi 
from rpu2device4xi import set2rpu4xi 
from spu2device4xi import set2spu4xi 
from tpu2device4xi import set2tpu4xi 
from upu2device4xi import set2upu4xi 
from vpu2device4xi import set2vpu4xi 
from xpu2device4xi import set2xpu4xi 
from wpu2device4xi import set2wpu4xi 
from ypu2device4xi import set2ypu4xi 
from zpu2device4xi import set2zpu4xi             

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global device4xi
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "init2device4xi" usage = "
#
# example 1:
#     print('=' *33)          
#     print('(Step 2A/33) OF DEVICE4XI5TEST - TRYING TO INITIALIZE DEVICE4XI', time4xi())
#     print('=' *33)       
#     try:
#         device2xi = init2device4xi()                                                                                # no parameters - the system should initialize all   
#         print('(Step 2B/33) OF DEVICE4XI5TEST - INITIALIZED DEVICE4XI TO: ', device2xi)                             # 
#     except:
#         print('(Step 2Z/33) OF DEVICE4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def init2device4xi(task4init2device=None):

    '''
    initializes device4xi
    '''
    global device4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "init2device4xi"
    method2print = "init2device4xi"

    message2print = "{(Step 1A/33) started" + "; init2device4xi-started: " + str(init2device4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function init2device4xi at 0x0000000003269848>; time: 05:21:07 05/05/11 Pacific Daylight Time} 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4init2device-to-init2device4xi: " + str(task4init2device) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'TYPE': 'CL_DEVICE_TYPE_VPU', 'ID': 4108}, 
    # 'DPU': {'TYPE': 'CL_DEVICE_TYPE_DPU', 'ID': 4103}, 
    # 'RPU': {'TYPE': 'CL_DEVICE_TYPE_RPU', 'ID': 4106}, 
    # 'SPU': {'TYPE': 'CL_DEVICE_TYPE_SPU', 'ID': 4107}, 
    # 'APU': {'TYPE': 'CL_DEVICE_TYPE_APU', 'ID': 4101}, 
    # 'PPU': {'TYPE': 'CL_DEVICE_TYPE_PPU', 'ID': 4105}, 
    # 'GPU': {'TYPE': 'CL_DEVICE_TYPE_GPU', 'ID': 4104}, 
    # 'CPU': {'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4102}
    #}; time: 09:59:06 05/08/11 Pacific Daylight Time}


    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4init2device is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM INITIALIZES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                              # 
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - DEVICE4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        if device4xi is None:                                                                                       #
            device4xi = {} 
            code2ack  = code2ack + '1D-'
    
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4init2device-try-by-init2device4xi: " + str(task4init2device)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'VPU': {'TYPE': 'CL_DEVICE_TYPE_VPU', 'ID': 4108}, 
    #  'DPU': {'TYPE': 'CL_DEVICE_TYPE_DPU', 'ID': 4103}, 
    #  'RPU': {'TYPE': 'CL_DEVICE_TYPE_RPU', 'ID': 4106}, 
    #  'SPU': {'TYPE': 'CL_DEVICE_TYPE_SPU', 'ID': 4107}, 
    #  'APU': {'TYPE': 'CL_DEVICE_TYPE_APU', 'ID': 4101}, 
    #  'PPU': {'TYPE': 'CL_DEVICE_TYPE_PPU', 'ID': 4105}, 
    #  'GPU': {'TYPE': 'CL_DEVICE_TYPE_GPU', 'ID': 4104}, 
    #  'CPU': {'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4102}
    # }; time: 09:59:06 05/08/11 Pacific Daylight Time}


    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES 
            # ----------------------------------------------------------------------------------------- 
        
            device4xi = {} 
            device4xi['APU'] = init2apu4xi()                                                                        
            device4xi['BPU'] = init2bpu4xi()                                                                        
            device4xi['CPU'] = init2cpu4xi()                                                                        
            device4xi['DPU'] = init2dpu4xi()                                                                        
            device4xi['EPU'] = init2epu4xi()                                                                        
            device4xi['FPU'] = init2fpu4xi()                                                                        
            device4xi['GPU'] = init2gpu4xi()                                                                        
            device4xi['HPU'] = init2hpu4xi()                                                                        
            device4xi['IPU'] = init2ipu4xi()                                                                        
            device4xi['JPU'] = init2jpu4xi()                                                                        
            device4xi['KPU'] = init2kpu4xi()                                                                        
            device4xi['LPU'] = init2lpu4xi()                                                                        
            device4xi['MPU'] = init2mpu4xi()                                                                        
            device4xi['NPU'] = init2npu4xi()                                                                        
            device4xi['OPU'] = init2opu4xi()                                                                        
            device4xi['PPU'] = init2ppu4xi()                                                                        
            device4xi['QPU'] = init2qpu4xi()                                                                        
            device4xi['RPU'] = init2rpu4xi()                                                                        
            device4xi['SPU'] = init2spu4xi()                                                                        
            device4xi['TPU'] = init2tpu4xi()                                                                        
            device4xi['UPU'] = init2upu4xi()                                                                        
            device4xi['VPU'] = init2vpu4xi()                                                                        
            device4xi['XPU'] = init2xpu4xi()                                                                        
            device4xi['WPU'] = init2wpu4xi()                                                                        
            device4xi['YPU'] = init2ypu4xi()                                                                        
            device4xi['ZPU'] = init2zpu4xi()                                                                        
            
                                         
            message2print = "{(Step 3A/33) initialized" + "; device4xi-initialized-by-init2device4xi to: " + str(device4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; device4xi-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          #   
            code2nack  = code2nack + '3Z1-'
    else:    

        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU 
            # -----------------------------------------------------------------------------------------               
            device4xi['APU'] = init2apu4xi(task4init2device['APU'])
            
            message2print = "{(Step AA/33) initialized" + "; apu-initialized-by-init2device4xi to: " + str(device4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'AA-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            device4xi['BPU'] = init2bpu4xi(task4init2device['BPU'])
            
            message2print = "{(Step BB/33) initialized" + "; abu-initialized-by-init2device4xi to: " + str(device4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'BB-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; abu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            device4xi['CPU'] = init2cpu4xi(task4init2device['CPU'])
            
            message2print = "{(Step CC/33) initialized" + "; cpu-initialized-by-init2device4xi to: " + str(device4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'CC-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            device4xi['DPU'] = init2dpu4xi(task4init2device['DPU'])
            
            message2print = "{(Step DD/33) initialized" + "; dpu-initialized-by-init2device4xi to: " + str(device4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'DD-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            device4xi['EPU'] = init2epu4xi(task4init2device['EPU'])
            
            message2print = "{(Step EE/33) initialized" + "; epu-initialized-by-init2device4xi to: " + str(device4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'EE-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            device4xi['FPU'] = init2fpu4xi(task4init2device['FPU'])
            
            message2print = "{(Step FF/33) initialized" + "; fpu-initialized-by-init2device4xi to: " + str(device4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'FF-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            device4xi['GPU'] = init2gpu4xi(task4init2device['GPU'])
            
            message2print = "{(Step GG/33) initialized" + "; gpu-initialized-by-init2device4xi to: " + str(device4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'GG-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            device4xi['HPU'] = init2hpu4xi(task4init2device['HPU'])
            
            message2print = "{(Step HH/33) initialized" + "; hpu-initialized-by-init2device4xi to: " + str(device4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'HH-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            device4xi['IPU'] = init2ipu4xi(task4init2device['IPU'])
            
            message2print = "{(Step II/33) initialized" + "; ipu-initialized-by-init2device4xi to: " + str(device4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'II-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            device4xi['JPU'] = init2jpu4xi(task4init2device['JPU'])
            
            message2print = "{(Step JJ/33) initialized" + "; jpu-initialized-by-init2device4xi to: " + str(device4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'JJ-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            device4xi['KPU'] = init2kpu4xi(task4init2device['KPU'])
            
            message2print = "{(Step KK/33) initialized" + "; kpu-initialized-by-init2device4xi to: " + str(device4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'KK-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            device4xi['LPU'] = init2lpu4xi(task4init2device['LPU'])
            
            message2print = "{(Step LL/33) initialized" + "; lpu-initialized-by-init2device4xi to: " + str(device4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'LL-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            device4xi['MPU'] = init2mpu4xi(task4init2device['MPU'])
            
            message2print = "{(Step MM/33) initialized" + "; mpu-initialized-by-init2device4xi to: " + str(device4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'MM-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            device4xi['NPU'] = init2npu4xi(task4init2device['NPU'])
            
            message2print = "{(Step NN/33) initialized" + "; npu-initialized-by-init2device4xi to: " + str(device4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'NN-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            device4xi['OPU'] = init2opu4xi(task4init2device['OPU'])
            
            message2print = "{(Step OO/33) initialized" + "; opu-initialized-by-init2device4xi to: " + str(device4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'OO-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            device4xi['PPU'] = init2ppu4xi(task4init2device['PPU'])
            
            message2print = "{(Step PP/33) initialized" + "; ppu-initialized-by-init2device4xi to: " + str(device4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'PP-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            device4xi['QPU'] = init2qpu4xi(task4init2device['QPU'])
            
            message2print = "{(Step QQ/33) initialized" + "; qpu-initialized-by-init2device4xi to: " + str(device4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'QQ-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            device4xi['RPU'] = init2rpu4xi(task4init2device['RPU'])
            
            message2print = "{(Step RR/33) initialized" + "; rpu-initialized-by-init2device4xi to: " + str(device4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'RR-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            device4xi['SPU'] = init2spu4xi(task4init2device['SPU'])
            
            message2print = "{(Step SS/33) initialized" + "; spu-initialized-by-init2device4xi to: " + str(device4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'SS-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            device4xi['TPU'] = init2tpu4xi(task4init2device['TPU'])
            
            message2print = "{(Step TT/33) initialized" + "; tpu-initialized-by-init2device4xi to: " + str(device4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'TT-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            device4xi['UPU'] = init2upu4xi(task4init2device['UPU'])
            
            message2print = "{(Step UU/33) initialized" + "; upu-initialized-by-init2device4xi to: " + str(device4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'UU-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            device4xi['VPU'] = init2vpu4xi(task4init2device['VPU'])
            
            message2print = "{(Step VV/33) initialized" + "; vpu-initialized-by-init2device4xi to: " + str(device4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'VV-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            device4xi['WPU'] = init2wpu4xi(task4init2device['WPU'])
            
            message2print = "{(Step WW/33) initialized" + "; wpu-initialized-by-init2device4xi to: " + str(device4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'WW-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            device4xi['XPU'] = init2xpu4xi(task4init2device['XPU'])
            
            message2print = "{(Step XX/33) initialized" + "; xpu-initialized-by-init2device4xi to: " + str(device4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'XX-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            device4xi['YPU'] = init2ypu4xi(task4init2device['YPU'])
            
            message2print = "{(Step YY/33) initialized" + "; ypu-initialized-by-init2device4xi to: " + str(device4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'YY-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            device4xi['ZPU'] = init2zpu4xi(task4init2device['ZPU'])
            
            message2print = "{(Step ZZ/33) initialized" + "; zpu-initialized-by-init2device4xi to: " + str(device4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'ZZ-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'     
                        

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{(Step 33/33) returning" + "; device4xi-returning-by-init2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    return device4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2device4xi" usage = "
#
# example 1:
#     print('(Step 4A/33) OF DEVICE4XI5TEST - TRYING TO SET CPU ID AND TYPE', time4xi())
#     task4set2device = {}
#     task4set2device ['CPU'] = {}
#     task4set2device ['CPU'] ['ID'] = 4098
#     task4set2device ['CPU'] ['TYPE'] = 'CL_DEVICE_TYPE_CPU'
# 
#     try:                               
#         response4set2device = set2device4xi(task4set2device)                                                       
#         print('(Step 4B/33) OF DEVICE4XI5TEST - RESPONSE4SET2DEVICE : ', response4set2device) 
#     except:
#         print('(Step 4Z1/33) OF DEVICE4XI5TEST *** FAILED TO SET CPU ID AND TYPE ', time4xi())                  
#
# example 2:
#     print('(Step 4C/33) OF DEVICE4XI5TEST - TRYING TO SET GPU ID AND TYPE', time4xi())
#     task4set2device = {}
#     task4set2device ['GPU'] = {}
#     task4set2device ['GPU'] ['ID'] = 4099
#     task4set2device ['GPU'] ['TYPE'] = 'CL_DEVICE_TYPE_GPU'
#   
#     try:                               
#         response4set2device = set2device4xi(task4set2device)                                                       
#         print('(Step 4D/33) OF DEVICE4XI5TEST - RESPONSE4SET2DEVICE : ', response4set2device) 
#     except:
#         print('(Step 4Z2/33) OF DEVICE4XI5TEST *** FAILED TO SET GPU ID AND TYPE ', time4xi())
#
# example 3:
#     print('(Step 5A/33) OF DEVICE4XI5TEST - CREATING DEVICE4XI OBJECT')
#     try:
#         # ---------------------------------------------------------------------------------------------
#         # CREATE OBJECT                        
#         # ---------------------------------------------------------------------------------------------        
#         cc2xi = Device4Xi()
#         print('(Step 5B/33) OF DEVICE4XI5TEST - CREATED DEVICE4XI OBJECT: ', cc2xi)                                  
#     except:
#         print('(Step 5Z/33) OF DEVICE4XI5TEST *** FAILED TO CREATE DEVICE4XI OBJECT')
#      
#     print('(Step 7A/33) OF DEVICE4XI5TEST - TRYING TO SET CPU ID AND TYPE', time4xi())
#     task4set2device = {}
#     task4set2device ['CPU'] = {}
#     task4set2device ['CPU'] ['ID'] = 4098
#     task4set2device ['CPU'] ['TYPE'] = 'CL_DEVICE_TYPE_CPU'
#   
#     try:                               
#         response4set2device = cc2xi.set2device(task4set2device)                                                       
#         print('(Step 7B/33) OF DEVICE4XI5TEST - RESPONSE4SET2DEVICE : ', response4set2device) 
#     except:
#         print('(Step 7Z1/33) OF DEVICE4XI5TEST *** FAILED TO SET CPU ID AND TYPE ', time4xi())           
#
# example 4:     
#     print('(Step 8A/33) OF DEVICE4XI5TEST - TRYING TO SET GPU ID AND TYPE', time4xi())
#     task4set2device = {}
#     task4set2device ['GPU'] = {}
#     task4set2device ['GPU'] ['ID'] = 4099
#     task4set2device ['GPU'] ['TYPE'] = 'CL_DEVICE_TYPE_GPU'
#   
#     try:                               
#         response4set2device = cc2xi.set2device(task4set2device)                                                       
#         print('(Step 8B/33) OF DEVICE4XI5TEST - RESPONSE4SET2DEVICE : ', response4set2device) 
#     except:
#         print('(Step 8Z1/33) OF DEVICE4XI5TEST *** FAILED TO SET GPU ID AND TYPE ', time4xi())             
#                            
#">

# -------------------------------------------------------------------------------------------------   
def set2device4xi(task4set2device=None):

    '''
    sets device4xi
    '''
    global device4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2device4xi"
    method2print = "set2device4xi"

    message2print = "{(Step 1A/33) started" + "; set2device4xi-started: " + str(set2device4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function set2device4xi at 0x0000000003269C48>; time: 05:21:08 05/05/11 Pacific Daylight Time}  
  
             
    message2print = "{(Step 1B/33) passed" + "; task4set2device-to-set2device4xi: " + str(task4set2device) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'ID': 4108}, 
    #  'DPU': {'ID': 4103}, 
    #  'RPU': {'ID': 4106}, 
    #  'SPU': {'ID': 4107}, 
    #  'APU': {'ID': 4101}, 
    #  'PPU': {'ID': 4105}, 
    #  'GPU': {'ID': 4104}, 
    #  'CPU': {'ID': 4102}
    # }; time: 09:17:55 05/08/11 Pacific Daylight Time}


             
    code2ack  = ' '
    code2nack = ' '

    if device4xi is None:
        device4xi = init2device4xi()
                                
        message2print = "{(Step 1C/33) set" + "; device4xi-set-by-set2device4xi to: " + str(device4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        


    # -----------------------------------------------------------------------------------------
    # (Step AA/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step AA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step AA/33) passing" + "; task-passing-to-set2apu4xi: " + str(task4set2device['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['APU'] = set2apu4xi(task4set2device['APU'])                                                     
         
        message2print = "{(Step AB/33) set" + "; apu-set-by-set2device4xi to: " + str(device4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'AB-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2device4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step BA/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step BA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step BA/33) passing" + "; task-passing-to-set2bpu4xi: " + str(task4set2device['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['BPU'] = set2bpu4xi(task4set2device['BPU'])                                                     
         
        message2print = "{(Step BB/33) set" + "; bpu-set-by-set2device4xi to: " + str(device4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'BB-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2device4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step CA/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step CA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step CA/33) passing" + "; task-passing-to-set2cpu4xi: " + str(task4set2device['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['CPU'] = set2cpu4xi(task4set2device['CPU'])                                                     
         
        message2print = "{(Step CB/33) set" + "; cpu-set-by-set2device4xi to: " + str(device4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'CB-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2device4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step DA/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step DA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step DA/33) passing" + "; task-passing-to-set2dpu4xi: " + str(task4set2device['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['DPU'] = set2dpu4xi(task4set2device['DPU'])                                                     
         
        message2print = "{(Step DB/33) set" + "; dpu-set-by-set2device4xi to: " + str(device4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'DB-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2device4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step EA/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step EA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step EA/33) passing" + "; task-passing-to-set2epu4xi: " + str(task4set2device['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['EPU'] = set2epu4xi(task4set2device['EPU'])                                                     
         
        message2print = "{(Step EB/33) set" + "; epu-set-by-set2device4xi to: " + str(device4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'EB-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2device4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step FA/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step FA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step FA/33) passing" + "; task-passing-to-set2fpu4xi: " + str(task4set2device['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['FPU'] = set2fpu4xi(task4set2device['FPU'])                                                     
         
        message2print = "{(Step FB/33) set" + "; fpu-set-by-set2device4xi to: " + str(device4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'FB-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2device4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step GA/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step GA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step GA/33) passing" + "; task-passing-to-set2gpu4xi: " + str(task4set2device['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['GPU'] = set2gpu4xi(task4set2device['GPU'])                                                     
         
        message2print = "{(Step GB/33) set" + "; gpu-set-by-set2device4xi to: " + str(device4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'GB-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2device4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step HA/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step HA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step HA/33) passing" + "; task-passing-to-set2hpu4xi: " + str(task4set2device['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['HPU'] = set2hpu4xi(task4set2device['HPU'])                                                     
         
        message2print = "{(Step HB/33) set" + "; hpu-set-by-set2device4xi to: " + str(device4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'HB-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2device4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step IA/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step IA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step IA/33) passing" + "; task-passing-to-set2ipu4xi: " + str(task4set2device['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['IPU'] = set2ipu4xi(task4set2device['IPU'])                                                     
         
        message2print = "{(Step IB/33) set" + "; ipu-set-by-set2device4xi to: " + str(device4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'IB-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2device4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step JA/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step JA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step JA/33) passing" + "; task-passing-to-set2jpu4xi: " + str(task4set2device['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['JPU'] = set2jpu4xi(task4set2device['JPU'])                                                     
         
        message2print = "{(Step JB/33) set" + "; jpu-set-by-set2device4xi to: " + str(device4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'JB-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2device4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step KA/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step KA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step KA/33) passing" + "; task-passing-to-set2kpu4xi: " + str(task4set2device['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['KPU'] = set2kpu4xi(task4set2device['KPU'])                                                     
         
        message2print = "{(Step KB/33) set" + "; kpu-set-by-set2device4xi to: " + str(device4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'KB-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2device4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step LA/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step LA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step LA/33) passing" + "; task-passing-to-set2lpu4xi: " + str(task4set2device['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['LPU'] = set2lpu4xi(task4set2device['LPU'])                                                     
         
        message2print = "{(Step LB/33) set" + "; lpu-set-by-set2device4xi to: " + str(device4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'LB-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2device4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step MA/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step MA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step MA/33) passing" + "; task-passing-to-set2mpu4xi: " + str(task4set2device['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['MPU'] = set2mpu4xi(task4set2device['MPU'])                                                     
         
        message2print = "{(Step MB/33) set" + "; mpu-set-by-set2device4xi to: " + str(device4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'MB-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2device4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step NA/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step NA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step NA/33) passing" + "; task-passing-to-set2npu4xi: " + str(task4set2device['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['NPU'] = set2npu4xi(task4set2device['NPU'])                                                     
         
        message2print = "{(Step NB/33) set" + "; npu-set-by-set2device4xi to: " + str(device4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'NB-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2device4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step OA/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step OA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step OA/33) passing" + "; task-passing-to-set2opu4xi: " + str(task4set2device['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['OPU'] = set2opu4xi(task4set2device['OPU'])                                                     
         
        message2print = "{(Step OB/33) set" + "; opu-set-by-set2device4xi to: " + str(device4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'OB-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2device4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step PA/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step PA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step PA/33) passing" + "; task-passing-to-set2ppu4xi: " + str(task4set2device['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['PPU'] = set2ppu4xi(task4set2device['PPU'])                                                     
         
        message2print = "{(Step PB/33) set" + "; ppu-set-by-set2device4xi to: " + str(device4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'PB-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2device4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step QA/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step QA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step QA/33) passing" + "; task-passing-to-set2qpu4xi: " + str(task4set2device['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['QPU'] = set2qpu4xi(task4set2device['QPU'])                                                     
         
        message2print = "{(Step QB/33) set" + "; qpu-set-by-set2device4xi to: " + str(device4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'QB-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2device4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step RA/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step RA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step RA/33) passing" + "; task-passing-to-set2rpu4xi: " + str(task4set2device['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['RPU'] = set2rpu4xi(task4set2device['RPU'])                                                     
         
        message2print = "{(Step RB/33) set" + "; rpu-set-by-set2device4xi to: " + str(device4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'RB-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2device4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step SA/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step SA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step SA/33) passing" + "; task-passing-to-set2spu4xi: " + str(task4set2device['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['SPU'] = set2spu4xi(task4set2device['SPU'])                                                     
         
        message2print = "{(Step SB/33) set" + "; spu-set-by-set2device4xi to: " + str(device4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'SB-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2device4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step TA/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step TA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step TA/33) passing" + "; task-passing-to-set2tpu4xi: " + str(task4set2device['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['TPU'] = set2tpu4xi(task4set2device['TPU'])                                                     
         
        message2print = "{(Step TB/33) set" + "; tpu-set-by-set2device4xi to: " + str(device4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'TB-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2device4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step UA/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step UA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step UA/33) passing" + "; task-passing-to-set2upu4xi: " + str(task4set2device['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['UPU'] = set2upu4xi(task4set2device['UPU'])                                                     
         
        message2print = "{(Step UB/33) set" + "; upu-set-by-set2device4xi to: " + str(device4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'UB-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2device4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step VA/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step VA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step VA/33) passing" + "; task-passing-to-set2vpu4xi: " + str(task4set2device['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['VPU'] = set2vpu4xi(task4set2device['VPU'])                                                     
         
        message2print = "{(Step VB/33) set" + "; vpu-set-by-set2device4xi to: " + str(device4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'VB-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2device4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step WA/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step WA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step WA/33) passing" + "; task-passing-to-set2wpu4xi: " + str(task4set2device['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['WPU'] = set2wpu4xi(task4set2device['WPU'])                                                     
         
        message2print = "{(Step WB/33) set" + "; wpu-set-by-set2device4xi to: " + str(device4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'WB-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2device4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step XA/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step XA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step XA/33) passing" + "; task-passing-to-set2xpu4xi: " + str(task4set2device['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['XPU'] = set2xpu4xi(task4set2device['XPU'])                                                     
         
        message2print = "{(Step XB/33) set" + "; xpu-set-by-set2device4xi to: " + str(device4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'XB-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2device4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step YA/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step YA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step YA/33) passing" + "; task-passing-to-set2ypu4xi: " + str(task4set2device['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['YPU'] = set2ypu4xi(task4set2device['YPU'])                                                     
         
        message2print = "{(Step YB/33) set" + "; ypu-set-by-set2device4xi to: " + str(device4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'YB-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2device4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
    # -----------------------------------------------------------------------------------------
    # (Step ZA/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step ZA/33)
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step ZA/33) passing" + "; task-passing-to-set2zpu4xi: " + str(task4set2device['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        device4xi ['ZPU'] = set2zpu4xi(task4set2device['ZPU'])                                                     
         
        message2print = "{(Step ZB/33) set" + "; zpu-set-by-set2device4xi to: " + str(device4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
     
        code2ack  = code2ack + 'ZB-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2device4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'
        

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; device4xi-returning-by-set2device4xi: " + str(device4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4108, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'DPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4103, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'RPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4106, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_RPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'SPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4107, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_SPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'APU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4101, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_APU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'PPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4105, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_PPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'GPU': {'RESOLUTION2TIMER4PROFILING': 1, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 0, 'MAX2UNITS4COMPUTE': 10, 'SIZE2MEMORY4GLOBAL': 536870912, 'NATIVE2WIDTHFLOAT4VECTOR': 0, 'MAX2SIZE4WORKGROUP': 256, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 0, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'ACK', 'TYPE4CACHE': None, 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 64, 'NATIVE2WIDTHINT4VECTOR': 0, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'NACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': 'CAL 1.4.900', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_gl_sharing cl_amd_device_attribute_query cl_khr_d3d10_sharing ', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 32, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 16384, 'VENDOR': 'Advanced Micro Devices, Inc.', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 1024, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 32768, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 750, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4104, 'MAX2WORKITEM2': 256, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'ATI RV770', 'MAX2WORKITEM1': 256, 'MAX2WORKITEM0': 256, 'SIZE2LINE4CACHE': 0, 'MAX2ALLOCATION4MEMORY': 134217728, 'NATIVE2WIDTHCHAR4VECTOR': 0, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 0, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.0 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 0, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_GPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'NACK'}, 
    #  'CPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4102, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}}; time: 09:59:06 05/08/11 Pacific Daylight Time}
 
    
    return device4xi

            
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2device4xi" usage = "
#
#    try:                               
#        response4get2device = get2device4xi()                                        
#                                                                                                                   
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2device4xi():

    '''
    gets get2device4xi
    '''
    
    global device4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2device4xi"
    method2print = "get2device4xi"

    message2print = "{(Step 1A/33) started" + "; get2device4xi-started: " + str(get2device4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # <function get2device4xi at 0x0000000003269CC8>; time: 05:21:08 05/05/11 Pacific Daylight Time}
     
    
    try:
        if device4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            device2xi = init2device4xi()
            message2print = "{(Step 1B/33) initialized" + "; device2xi-initialized-by-get2device4xi to: " + str(device2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                
        else:
            device2xi = device4xi    
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            device2xi = init2device4xi()
            message2print = "{(Step 1C/33) initialized" + "; device2xi-initialized-by-get2device4xi to: " + str(device2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                
        except:
            device2xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; device2xi-yielded-by-get2device4xi: " + str(device2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                        
            
            
            
    message2print = "{(Step 33/33) returning" + "; device2xi-returning-by-get2device: " + str(device2xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4005, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'DPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'RPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_RPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'SPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4012, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_SPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'APU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_APU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'PPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_PPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
    #  'GPU': {'RESOLUTION2TIMER4PROFILING': 1, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 0, 'MAX2UNITS4COMPUTE': 10, 'SIZE2MEMORY4GLOBAL': 536870912, 'NATIVE2WIDTHFLOAT4VECTOR': 0, 'MAX2SIZE4WORKGROUP': 256, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 0, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'ACK', 'TYPE4CACHE': None, 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 64, 'NATIVE2WIDTHINT4VECTOR': 0, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'NACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': 'CAL 1.4.900', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_gl_sharing cl_amd_device_attribute_query cl_khr_d3d10_sharing ', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 32, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 16384, 'VENDOR': 'Advanced Micro Devices, Inc.', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 1024, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 32768, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 750, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4021, 'MAX2WORKITEM2': 256, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'ATI RV770', 'MAX2WORKITEM1': 256, 'MAX2WORKITEM0': 256, 'SIZE2LINE4CACHE': 0, 'MAX2ALLOCATION4MEMORY': 134217728, 'NATIVE2WIDTHCHAR4VECTOR': 0, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 0, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.0 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 0, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_GPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'NACK'}, 
    #  'CPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C1D1E1F1D2A3A4A5A6A7A8A9A10A11A12A13A14A15A16A17A18A19A20A21A22A23A24A25A26A27A28A29A30A31A32A33A34A35A36A37A38A39A40A41A42A43A44A45A46A47A48A49A50A51A52A53A54A55A56A57A58A59A60A', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
    #          'ID': 4017, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}}; time: 10:30:14 05/08/11 Pacific Daylight Time}


    
    return device2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "Device4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for Device" usage = "OpenCL Device"
#>

# =================================================================================================
class Device4Xi(object): 
    ''' 
    Device4Xi offers  methods for Device
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2device = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'init2device',
    'get2device',
    'set2device',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Device4Xi" usage = "initializes Device4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4init2device = None):
        '''
        _init__ method initializes Device4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Device4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-Device4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 05:21:08 05/05/11 Pacific Daylight Time} 

        message2print = "{(Step 1B/33) borning" + "; device2xi-of-Device4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # time: 05:21:08 05/05/11 Pacific Daylight Time}   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-device2xi-of-Device4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2device-sharing-by-device2xi-of-Device4Xi: " + str(Device4Xi.classvariable2device)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                 
                                
        message2print = "{(Step 1E/33) passed" + "; task4init2device-passed-to-init-of-Device4Xi: " + str(task4init2device) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                                  
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4init2device-passing-to-init2device4xi-by-init-of-Device4Xi: " + str(task4init2device) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None    
        
        device2xi = init2device4xi(task4init2device)
        
        message2print = "{(Step 2B/33) performed" + "; init2device4xi-performed-by-init-of-Device4Xi: " + str(init2device4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function init2device4xi at 0x0000000003269848>; time: 05:21:08 05/05/11 Pacific Daylight Time}     
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; device2xi-of-Device4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 05:21:08 05/05/11 Pacific Daylight Time 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-device2xi-of-Device4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>; time: 05:21:08 05/05/11 Pacific Daylight Time    
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2device-shared-by-device2xi-of-Device4Xi: " + str(Device4Xi.classvariable2device)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                 
       
        message2print = "{(Step 3D/33) returning" + "; init-of-Device4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 05:21:08 05/05/11 Pacific Daylight Time 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Device4Xi" usage = "initializes objects of Device4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def init2device(self, task4init2device = None):
        '''
        init2device method initializes objects of Device4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)            
        # -----------------------------------------------------------------------------------------              
        class2print = "Device4Xi"
        method2print = "init2device"
                      
        message2print = "{(Step 1A/33) started" + "; init-of-Device4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4init2device-passed-to-init-of-Device4Xi: " + str(task4init2device) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'VPU': {'TYPE': 'CL_DEVICE_TYPE_VPU', 'ID': 4108}, 
        #  'DPU': {'TYPE': 'CL_DEVICE_TYPE_DPU', 'ID': 4103}, 
        #  'RPU': {'TYPE': 'CL_DEVICE_TYPE_RPU', 'ID': 4106}, 
        #  'SPU': {'TYPE': 'CL_DEVICE_TYPE_SPU', 'ID': 4107}, 
        #  'APU': {'TYPE': 'CL_DEVICE_TYPE_APU', 'ID': 4101}, 
        #  'PPU': {'TYPE': 'CL_DEVICE_TYPE_PPU', 'ID': 4105}, 
        #  'GPU': {'TYPE': 'CL_DEVICE_TYPE_GPU', 'ID': 4104}, 
        #  'CPU': {'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4102}
        #}; time: 09:59:06 05/08/11 Pacific Daylight Time}
                                  
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4init2device-passing-to-init2device4xi-by-init-of-Device4Xi: " + str(task4init2device) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'TYPE': 'CL_DEVICE_TYPE_VPU', 'ID': 4108}, 
        #  'DPU': {'TYPE': 'CL_DEVICE_TYPE_DPU', 'ID': 4103}, 
        #  'RPU': {'TYPE': 'CL_DEVICE_TYPE_RPU', 'ID': 4106},
        #  'SPU': {'TYPE': 'CL_DEVICE_TYPE_SPU', 'ID': 4107},
        #  'APU': {'TYPE': 'CL_DEVICE_TYPE_APU', 'ID': 4101},
        #  'PPU': {'TYPE': 'CL_DEVICE_TYPE_PPU', 'ID': 4105}, 
        #  'GPU': {'TYPE': 'CL_DEVICE_TYPE_GPU', 'ID': 4104}, 
        #  'CPU': {'TYPE': 'CL_DEVICE_TYPE_CPU', 'ID': 4102}
        # }; time: 09:59:06 05/08/11 Pacific Daylight Time}
       
                
  
        device2xi = init2device4xi(task4init2device)

        message2print = "{(Step 2B/33) performed" + "; init2device4xi-performed-by-init-of-Device4Xi: " + str(init2device4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function init2device4xi at 0x0000000003269848>; time: 05:21:08 05/05/11 Pacific Daylight Time
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; device2xi-returning-by-init2device-of-Device4Xi: " + str(device2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_VPU', 
        #          'ID': 4108}, 
        #  'DPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_DPU', 
        #          'ID': 4103}, 
        #  'RPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_RPU', 
        #          'ID': 4106}, 
        #  'SPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_SPU', 
        #          'ID': 4107}, 
        #  'APU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_APU', 
        #          'ID': 4101}, 
        #  'PPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_PPU', 
        #          'ID': 4105}, 
        #  'GPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_GPU', 
        #          'ID': 4104}, 
        #  'CPU': {'NACK2RETURN': ' 4Z15Z16Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 1C2A3A', 'TYPE': 'CL_DEVICE_TYPE_CPU', 
        #          'ID': 4102}}; time: 10:30:15 05/08/11 Pacific Daylight Time}
 

                
        return device2xi
                                
                            
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2device-of-Device4Xi" usage = "sets objects of Device4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def set2device(self, task4set2device = None):
        '''
        set2device method sets objects of Device4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Device4Xi"
        method2print = "set2device"
                     
        message2print = "{(Step 1A/33) started" + "; set2device-of-Device4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:21:08 05/05/11 Pacific Daylight Time
            
        message2print = "{(Step 1B/33) passed" + "; task4set2device-passed-to-set2device-of-Device4Xi: " + str(task4set2device) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'CPU': {'TYPE': 'CL_DEVICE_TYPE_CPU2', 'ID': 40982}}                                                               
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2device-passing-to-set2device4xi-by-set2device-of-Device4Xi: " + str(task4set2device) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'CPU': {'TYPE': 'CL_DEVICE_TYPE_CPU2', 'ID': 40982}}        
                
  
        device2xi = set2device4xi(task4set2device)

        message2print = "{(Step 2B/33) performed" + "; set2device4xi-performed-by-set2device-of-Device4Xi: " + str(set2device4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function set2device4xi at 0x0000000003269C48>; time: 05:21:08 05/05/11 Pacific Daylight Time
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; device2xi-returning-by-set2device-of-Device4Xi: " + str(device2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_DPU', 
        #          'ID': 4218, 'MAX2UNITS4COMPUTE': 4}, 
        #  'DPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
        #          'ID': 4213, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
        #  'RPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_RPU', 
        #          'ID': 4216, 'MAX2UNITS4COMPUTE': 4}, 
        #  'SPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_SPU', 
        #          'ID': 4217, 'MAX2UNITS4COMPUTE': 4}, 
        #  'APU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_APU', 
        #          'ID': 4211, 'MAX2UNITS4COMPUTE': 4}, 
        #  'PPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_PPU', 
        #          'ID': 4215, 'MAX2UNITS4COMPUTE': 4}, 
        #  'GPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_GPU', 
        #          'ID': 4214, 'MAX2UNITS4COMPUTE': 10}, 
        #  'CPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_CPU', 
        #          'ID': 4212, 'MAX2UNITS4COMPUTE': 4}}; time: 10:30:15 05/08/11 Pacific Daylight Time}

                
        return device2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2device-of-Device4Xi" usage = "gets objects of Device4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def get2device(self):
        '''
        get2device method gets objects of Device4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Device4Xi"
        method2print = "get2device"
                     
        message2print = "{(Step 1A/33) started" + "; get2device-of-Device4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 05:21:08 05/05/11 Pacific Daylight Time   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        device2xi = get2device4xi()
        
        message2print = "{(Step 2A/33) returning" + "; device2xi-returning-by-get2device-of-Device4Xi: " + str(device2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # {'VPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_DPU', 
        #          'ID': 4218, 'MAX2UNITS4COMPUTE': 4}, 
        #  'DPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 2A4A4I', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 
        #          'ID': 4213, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 
        #  'RPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_RPU', 
        #          'ID': 4216, 'MAX2UNITS4COMPUTE': 4}, 
        #  'SPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_SPU', 
        #          'ID': 4217, 'MAX2UNITS4COMPUTE': 4}, 
        #  'APU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_APU', 
        #          'ID': 4211, 'MAX2UNITS4COMPUTE': 4}, 
        #  'PPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_PPU', 
        #          'ID': 4215, 'MAX2UNITS4COMPUTE': 4}, 
        #  'GPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_GPU', 
        #          'ID': 4214, 'MAX2UNITS4COMPUTE': 10}, 
        #  'CPU': {'NACK2RETURN': ' 6Z17Z18Z19Z110Z111Z112Z113Z114Z115Z116Z117Z118Z119Z120Z121Z122Z123Z124Z125Z126Z127Z128Z129Z130Z131Z132Z133Z134Z135Z136Z137Z138Z139Z140Z141Z142Z143Z144Z145Z146Z147Z148Z149Z150Z151Z152Z153Z154Z155Z156Z157Z158Z159Z160Z1', 'ACK2RETURN': ' 2A4A4I', 'TYPE': 'CL_DEVICE_TYPE_CPU', 
        #          'ID': 4212, 'MAX2UNITS4COMPUTE': 4}}; time: 10:30:15 05/08/11 Pacific Daylight Time}
 
        
                
        return device2xi
                                
                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Device4Xi" usage = "senses Device4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Device4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Device4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Device4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:21:08 05/05/11 Pacific Daylight Time
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Device4Xi-sensing-by-sense-of-Device4Xi: " + str(Device4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'device4xi.Device4Xi'>; time: 05:21:08 05/05/11 Pacific Daylight Time                
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Device4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object': <device4xi.Device4Xi object at 0x00000000033C6BA8>}; time: 05:21:08 05/05/11 Pacific Daylight Time}       
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2device-of-Device4Xi'] = Device4Xi.classvariable2device
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Device4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Device4Xi-sensed-by-sense-of-Device4Xi: " + str(Device4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # <class 'device4xi.Device4Xi'>; time: 05:21:08 05/05/11 Pacific Daylight Time}
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Device4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # kb2xi-returning-by-sense-of-Device4Xi: 
        # {'object': <device4xi.Device4Xi object at 0x00000000034DC4E0>, 'classvariable2device-of-Device4Xi': None}

                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Device4Xi" usage = "reasons Device4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Device4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Device4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Device4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:21:08 05/05/11 Pacific Daylight Time 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Device4Xi-reasoning-by-reason-of-Device4Xi: " + str(Device4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <class 'device4xi.Device4Xi'>; time: 05:21:08 05/05/11 Pacific Daylight Time}        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Device4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object-reason-object4xi': <device4xi.Device4Xi object at 0x00000000033C6BA8>}; time: 05:21:08 05/05/11 Pacific Daylight Time}        
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Device4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Device4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Device4Xi-reasoned-by-reason-of-Device4Xi: " + str(Device4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # <class 'device4xi.Device4Xi'>; time: 05:21:08 05/05/11 Pacific Daylight Time}
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Device4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # {'object-reason-object4xi': <device4xi.Device4Xi object at 0x00000000034DC4E0>, 'time-reason-of-Device4Xi': '10:30:15 05/08/11 Pacific Daylight Time'}
  
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Device4Xi" usage = "aces Device4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Device4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Device4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Device4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:21:08 05/05/11 Pacific Daylight Time      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Device4Xi-acing-by-ace-of-Device4Xi: " + str(Device4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'device4xi.Device4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Device4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object8xi': <device4xi.Device4Xi object at 0x00000000033C6BA8>}; time: 05:21:08 05/05/11 Pacific Daylight Time}        


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['time-ace-of-Device4Xi'] = time4xi()
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Device4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Device4Xi-aced-by-ace-of-Device4Xi: " + str(Device4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'device4xi.Device4Xi'>; time: 05:21:08 05/05/11 Pacific Daylight Time}
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Device4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # {'time-ace-of-Device4Xi': '10:30:15 05/08/11 Pacific Daylight Time', 'object8xi': <device4xi.Device4Xi object at 0x00000000034DC4E0>}
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   get2device4xi5test.txt
#   sense-test-get2device4xi.xml
#   reason-test-get2device4xi.xml
#   ace-test-get2device4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of device4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
